uniform Image palette;

uniform number base = 64;
uniform number size = 512;

vec4 effect(vec4 color, Image tex, vec2 texcoord, vec2 pixcoord) {
    vec4 c = Texel(tex, texcoord);

    c = max(c, vec4(0,0,0,1));

    number i = floor(c.r * (base-1))
        + floor(c.g * (base-1))*base
        + floor(c.b * (base-1))*base*base;
    return Texel(palette, vec2(floor(i/size) + 0.5, mod(i, size) + 0.5)/size);
}
